------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Byte_Arrays;
with Qt4.Objects;
with Qt4.String_Lists;
with Qt4.Strings;
with Qt4.Variants;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Mime_Datas is

   type Q_Mime_Data is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Mime_Data_Access is
     access all Q_Mime_Data'Class;
   for Q_Mime_Data_Access'Storage_Size use 0;

   type Q_Mime_Data_Pointer is tagged;

   procedure Clear
    (Self : not null access Q_Mime_Data'Class);

   function Color_Data
    (Self : not null access constant Q_Mime_Data'Class)
       return Qt4.Variants.Q_Variant;

   function Data
    (Self : not null access constant Q_Mime_Data'Class;
     Mime_Type : Qt4.Strings.Q_String)
       return Qt4.Byte_Arrays.Q_Byte_Array;

   not overriding
   function Formats
    (Self : not null access constant Q_Mime_Data)
       return Qt4.String_Lists.Q_String_List
         is abstract;

   function Has_Color
    (Self : not null access constant Q_Mime_Data'Class)
       return Standard.Boolean;

   not overriding
   function Has_Format
    (Self : not null access constant Q_Mime_Data;
     Mime_Type : Qt4.Strings.Q_String)
       return Standard.Boolean
         is abstract;

   function Has_Html
    (Self : not null access constant Q_Mime_Data'Class)
       return Standard.Boolean;

   function Has_Image
    (Self : not null access constant Q_Mime_Data'Class)
       return Standard.Boolean;

   function Has_Text
    (Self : not null access constant Q_Mime_Data'Class)
       return Standard.Boolean;

   function Has_Urls
    (Self : not null access constant Q_Mime_Data'Class)
       return Standard.Boolean;

   function Html
    (Self : not null access constant Q_Mime_Data'Class)
       return Qt4.Strings.Q_String;

   function Image_Data
    (Self : not null access constant Q_Mime_Data'Class)
       return Qt4.Variants.Q_Variant;

   procedure Remove_Format
    (Self : not null access Q_Mime_Data'Class;
     Mime_Type : Qt4.Strings.Q_String);

   procedure Set_Color_Data
    (Self : not null access Q_Mime_Data'Class;
     Color : Qt4.Variants.Q_Variant);

   procedure Set_Data
    (Self : not null access Q_Mime_Data'Class;
     Mime_Type : Qt4.Strings.Q_String;
     Data : Qt4.Byte_Arrays.Q_Byte_Array);

   procedure Set_Html
    (Self : not null access Q_Mime_Data'Class;
     Html : Qt4.Strings.Q_String);

   procedure Set_Image_Data
    (Self : not null access Q_Mime_Data'Class;
     Image : Qt4.Variants.Q_Variant);

   procedure Set_Text
    (Self : not null access Q_Mime_Data'Class;
     Text : Qt4.Strings.Q_String);

   function Text
    (Self : not null access constant Q_Mime_Data'Class)
       return Qt4.Strings.Q_String;

   package Q_Mime_Data_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Mime_Data, Q_Mime_Data_Access);

   type Q_Mime_Data_Pointer is
     new Q_Mime_Data_Pointers.Q_Pointer with null record;

end Qt4.Mime_Datas;
